/* -------------------------------------------------
                     mpx_conc.h

   CONC Verknuepfungen zum Erstellen der Initial-
   iesierung der Ports, sowie der Makros zum Lesen
   und Schreiben der Ports

   31.01.22 by R. Seelig
  -------------------------------------------------- */

  // ----------------------------------------------------------------
  // Praeprozessormacros um 2 Stringtexte zur weiteren Verwendung
  // innerhalb des Praeprozessors  zu verknuepfen
  //
  // Bsp.:
  //        #define ionr      A
  //        #define ioport    CONC(PORT, ionr)
  //
  //        ioport wird nun als "PORTA" behandelt
  // ----------------------------------------------------------------
  #define CONC2EXP(a,b)         a ## b
  #define CONC(a,b)             CONC2EXP(a, b)

  #define kseg7_init()          CONC(P,CONC(kseg7,_output_init()))
  #define kseg7_set()           CONC(P,CONC(kseg7,_set()))
  #define kseg7_clr()           CONC(P,CONC(kseg7,_clr()))

  #define kseg6_init()          CONC(P,CONC(kseg6,_output_init()))
  #define kseg6_set()           CONC(P,CONC(kseg6,_set()))
  #define kseg6_clr()           CONC(P,CONC(kseg6,_clr()))

  #define kseg5_init()          CONC(P,CONC(kseg5,_output_init()))
  #define kseg5_set()           CONC(P,CONC(kseg5,_set()))
  #define kseg5_clr()           CONC(P,CONC(kseg5,_clr()))

  #define kseg4_init()          CONC(P,CONC(kseg4,_output_init()))
  #define kseg4_set()           CONC(P,CONC(kseg4,_set()))
  #define kseg4_clr()           CONC(P,CONC(kseg4,_clr()))

  #define kseg3_init()          CONC(P,CONC(kseg3,_output_init()))
  #define kseg3_set()           CONC(P,CONC(kseg3,_set()))
  #define kseg3_clr()           CONC(P,CONC(kseg3,_clr()))

  #define kseg2_init()          CONC(P,CONC(kseg2,_output_init()))
  #define kseg2_set()           CONC(P,CONC(kseg2,_set()))
  #define kseg2_clr()           CONC(P,CONC(kseg2,_clr()))

  #define kseg1_init()          CONC(P,CONC(kseg1,_output_init()))
  #define kseg1_set()           CONC(P,CONC(kseg1,_set()))
  #define kseg1_clr()           CONC(P,CONC(kseg1,_clr()))

  #define kseg0_init()          CONC(P,CONC(kseg0,_output_init()))
  #define kseg0_set()           CONC(P,CONC(kseg0,_set()))
  #define kseg0_clr()           CONC(P,CONC(kseg0,_clr()))

  #define a_seginit()           CONC(P,CONC(seg_a,_output_init()))
  #define a_segset()            CONC(P,CONC(seg_a,_set()))
  #define a_segclr()            CONC(P,CONC(seg_a,_clr()))

  #define b_seginit()           CONC(P,CONC(seg_b,_output_init()))
  #define b_segset()            CONC(P,CONC(seg_b,_set()))
  #define b_segclr()            CONC(P,CONC(seg_b,_clr()))

  #define c_seginit()           CONC(P,CONC(seg_c,_output_init()))
  #define c_segset()            CONC(P,CONC(seg_c,_set()))
  #define c_segclr()            CONC(P,CONC(seg_c,_clr()))

  #define d_seginit()           CONC(P,CONC(seg_d,_output_init()))
  #define d_segset()            CONC(P,CONC(seg_d,_set()))
  #define d_segclr()            CONC(P,CONC(seg_d,_clr()))

  #define e_seginit()           CONC(P,CONC(seg_e,_output_init()))
  #define e_segset()            CONC(P,CONC(seg_e,_set()))
  #define e_segclr()            CONC(P,CONC(seg_e,_clr()))

  #define g_seginit()           CONC(P,CONC(seg_g,_output_init()))
  #define g_segset()            CONC(P,CONC(seg_g,_set()))
  #define g_segclr()            CONC(P,CONC(seg_g,_clr()))

  #define f_seginit()           CONC(P,CONC(seg_f,_output_init()))
  #define f_segset()            CONC(P,CONC(seg_f,_set()))
  #define f_segclr()            CONC(P,CONC(seg_f,_clr()))

  #define dp_seginit()          CONC(P,CONC(seg_dp,_output_init()))
  #define dp_segset()           CONC(P,CONC(seg_dp,_set()))
  #define dp_segclr()           CONC(P,CONC(seg_dp,_clr())) 

  #define key_0_4_init()        CONC(P,CONC(key_0_4,_input_init()))
  #define key_1_5_init()        CONC(P,CONC(key_1_5,_input_init()))
  #define key_2_6_init()        CONC(P,CONC(key_2_6,_input_init()))
  #define key_3_7_init()        CONC(P,CONC(key_3_7,_input_init()))
    
  #define is_key_0_4()          CONC(is_P,key_0_4())
  #define is_key_1_5()          CONC(is_P,key_1_5())
  #define is_key_2_6()          CONC(is_P,key_2_6())
  #define is_key_3_7()          CONC(is_P,key_3_7())

